#include "opencv2/highgui/highgui.hpp"
#include "opencv2/imgproc/imgproc.hpp"
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

using namespace cv;

/*
	Prevedie HSV(0..359,0..100,0..100) do HSV(0..179,0..255,0..255), ktory sa vyuziva v openCV
*/
Scalar getHSV(int hue_0_360, int sat_0_100, int val_0_100);

string intToStr(int i);
/*
	Nakresli do obrazku polygon a jeho nazov
*/
void drawShape(vector<Point> vector, Mat& img, String label);
/*
	Vypocita double vzdialenost dvoch bodov v 2D
*/
double dist(double x1, double y1, double x2, double y2);

double getCenter(double p1, double p2);

Point getCenterPoint(Point p1, Point p2);

Point getCenterPoint(vector<Point> v);

double getLongestTriangleEdgeLength(vector<Point>& triangle);

vector<Point> getLongestTriangleEdge(vector<Point>& triangle);

/*
	Vrati -1, 0 alebo +1 podla vzajomnej Y pozicie bodu a priamky zadanej dvoma bodmi
*/
int getMutualYposition(double pointX, double pointY, double p1x, double p1y, double p2x, double p2y);

/*
	Vrati -1, 0 alebo +1 podla vzajomnej Y pozicie bodu a priamky zadanej dvoma bodmi
*/
int getMutualYposition(Point2d point, Point2d p1, Point2d p2);

/*
	Vrati uhol robota podla zadanych bodov trojuholnika. hore +0, vpravo +90, dole +180, vlavo -90
*/
double getRobotAngle(vector<Point>& triangle);

double radToDeg(double rad);

/*
	Modifikovana funkcia z internetu
*/
vector<Point> getTriangleVertices(const vector< vector<Point> >& contours, int minTriangleArea=0);

vector<Point> findArrow(Mat imageRGB, Scalar minHSV, Scalar maxHSV, int minTriangleArea, string label="");