#include "opencv2/highgui/highgui.hpp"
#include "opencv2/imgproc/imgproc.hpp"
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#include "arrowdetection.h"

using namespace std;
using namespace cv;

int main(int argc, char* argv[])
 {
	 cout << ":::Robot angle tester:::\n";
	 Mat src_rgb = cv::imread("images/otocenia/90.jpg",1);

	 if (!src_rgb.data){
		 cout << "No image\n";
		 return 5;
	 }

	// orange
	Scalar MIN_ORANGE_HSV = getHSV(18,50,55);
	Scalar MAX_ORANGE_HSV = getHSV(40,86,66);

	// purple
	Scalar MIN_PURPLE_HSV = getHSV(315,35,40);
	Scalar MAX_PURPLE_HSV = getHSV(359,70,54);

	vector<Point> orange_arrow = findArrow(src_rgb, MIN_ORANGE_HSV, MAX_ORANGE_HSV, 300, "orange");
	vector<Point> purple_arrow = findArrow(src_rgb, MIN_PURPLE_HSV, MAX_PURPLE_HSV, 300, "purple");

	if (orange_arrow.size()==3){
		cout << "\n:::orange robot:::\n";
		drawShape(orange_arrow, src_rgb, "ORANGE ROBOT");
		cout << "triangle " << orange_arrow << "\n";
		cout << "angle " << radToDeg(getRobotAngle(orange_arrow)) << "\n";
	}else cout << "No orange robot\n";

	if (orange_arrow.size()==3){
		cout << "\n:::purple robot:::\n";
		drawShape(purple_arrow, src_rgb, "PURPLE ROBOT");
		cout << "triangle " << purple_arrow << "\n";
		cout << "angle " << radToDeg(getRobotAngle(purple_arrow)) << "\n";
	}else cout << "No purple robot\n";

	namedWindow( "original", WINDOW_AUTOSIZE );
	imshow("original", src_rgb);

	waitKey(0);

	return 0;
 }